<script lang="ts">
  import { Color, getTileEmoji } from "../util";

  export let color: Color | null = null;
  export let penalty: number = 0;

  $: colorClass = color !== null ? getColorClass(color) : "";

  function getColorClass(color: Color): string {
    switch (color) {
      case Color.Blue:
        return "tile-blue";
      case Color.Red:
        return "tile-red";
      case Color.Yellow:
        return "tile-yellow";
      case Color.Black:
        return "tile-black";
      case Color.White:
        return "tile-white";
    }
  }
</script>

<div class="tile {colorClass}" class:penalty>
  {#if penalty !== 0}
    <div class="penalty-value">
      {penalty.toString().replace("-", "−")}
    </div>
  {/if}
  {#if color !== null}
    <div class="emoji-wrapper">
      <div class="emoji">{getTileEmoji(color)}</div>
    </div>
  {/if}
  <slot />
</div>

<style>
  .tile {
    position: relative;
    height: 1.25em;
    width: 1.25em;

    background: transparent;

    position: relative;
    border-radius: 0.2em;

    --hatch-width: 0.125em;
    --double-hatch-width: calc(var(--hatch-width) * 2);

    border: solid 1px var(--board-border-color);
  }

  .tile.penalty {
    border-color: #8008;
  }
  .penalty-value {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    font-size: 75%;
    font-weight: bold;
    color: #8008;
  }

  .emoji {
    font-size: 67%;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%) translateY(0.033em);

    filter: drop-shadow(0 0 1px #0007);
  }
  .emoji-wrapper {
    height: 100%;
    filter: drop-shadow(0 0 0.033em #000a) opacity(0.5);
  }

  .tile-blue .emoji {
    --tile-blue-color: hsl(219deg 64% 53%);
  }
  .tile-red .emoji {
    --tile-red-color: hsl(0deg 82% 58%);
  }
  .tile-yellow .emoji {
    --tile-yellow-color: hsl(47deg 100% 50%);
  }
  .tile-black .emoji {
    --tile-black-color: hsl(0deg 0% 31%);
  }
  .tile-white .emoji {
    --tile-white-color: hsl(0deg 0% 100%);

    filter: brightness(1.2) saturate(0);
  }
</style>
